/*
 ============================================================================
 Name        : sinal.c
 Author      : Anderson Moreira
 E-mail		 : anderson.moreira@recife.ifpe.edu.br
 Version     : 17/06/2011
 Copyright   : 
 Description : Programa similar ao SIGNAL_4 porm o processo filho espera por
  	  	  	   5 segundos antes de enviar um sinal SIGALRM para seu pai. O
  	  	  	   programa tambm manda um alarme.
 ============================================================================
 */

#include <signal.h> // definio dos sinais de interrupes
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>

void alarme(int sig)
{
	printf("Alarme foi desligado. \n");
}

int main()
{
	int pid;

	printf("O alarme foi disparado. \n");

	if ((pid = fork()) == 0){
		// cdigo do processo filho
		printf("\n\n            Execucao do Filho- vai dormir por 5 segundos\n");
		sleep(5);
		kill(getppid(), SIGALRM);
		printf("            Execucao do Filho- filho vai morrer\n\n");
		exit(0);
	}

	printf("Pai esperando pelo Sinal de alarme desligar (5s).\n");
	printf(" Apos a funcao signal()\n");
	pause();
	printf("O sinal de alarme chegou ao Pai .\n");
	exit(0);
}
